Parameter
Date: 2016-05-24

com.google.common.reflect

## Class Parameter

- java.lang.Object
- - com.google.common.reflect.Parameter

- All Implemented Interfaces:
    java.lang.reflect.AnnotatedElement

      @Beta
      public final class Parameter
      extends java.lang.Object
      implements java.lang.reflect.AnnotatedElement

  Represents a method or constructor parameter.
  Since:
    14.0

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `equals(java.lang.Object obj)`
    `<A extends java.lang.annotation.Annotation> A` | `getAnnotation(java.lang.Class<A> annotationType)`
    `java.lang.annotation.Annotation[]` | `getAnnotations()`
    `<A extends java.lang.annotation.Annotation> A[]` | `getAnnotationsByType(java.lang.Class<A> annotationType)`
    `<A extends java.lang.annotation.Annotation> A` | `getDeclaredAnnotation(java.lang.Class<A> annotationType)`
    `java.lang.annotation.Annotation[]` | `getDeclaredAnnotations()`
    `<A extends java.lang.annotation.Annotation> A[]` | `getDeclaredAnnotationsByType(java.lang.Class<A> annotationType)`
    `Invokable<?,?>` | `getDeclaringInvokable()` Returns the `Invokable` that declares this parameter.
    `TypeToken<?>` | `getType()` Returns the type of the parameter.
    `int` | `hashCode()`
    `boolean` | `isAnnotationPresent(java.lang.Class<? extends java.lang.annotation.Annotation> annotationType)`
    `java.lang.String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Method Detail

    - #### getType

          public TypeToken<?> getType()

      Returns the type of the parameter.

    - #### getDeclaringInvokable

          public Invokable<?,?> getDeclaringInvokable()

      Returns the `Invokable` that declares this parameter.

    - #### isAnnotationPresent

          public boolean isAnnotationPresent(java.lang.Class<? extends java.lang.annotation.Annotation> annotationType)

      Specified by:
        `isAnnotationPresent` in interface `java.lang.reflect.AnnotatedElement`

    - #### getAnnotation

          @Nullable
          public <A extends java.lang.annotation.Annotation> A getAnnotation(java.lang.Class<A> annotationType)

      Specified by:
        `getAnnotation` in interface `java.lang.reflect.AnnotatedElement`

    - #### getAnnotations

          public java.lang.annotation.Annotation[] getAnnotations()

      Specified by:
        `getAnnotations` in interface `java.lang.reflect.AnnotatedElement`

    - #### getAnnotationsByType

          public <A extends java.lang.annotation.Annotation> A[] getAnnotationsByType(java.lang.Class<A> annotationType)

      Since:
        18.0

    - #### getDeclaredAnnotations

          public java.lang.annotation.Annotation[] getDeclaredAnnotations()

      Specified by:
        `getDeclaredAnnotations` in interface `java.lang.reflect.AnnotatedElement`
      Since:
        18.0

    - #### getDeclaredAnnotation

          @Nullable
          public <A extends java.lang.annotation.Annotation> A getDeclaredAnnotation(java.lang.Class<A> annotationType)

      Since:
        18.0

    - #### getDeclaredAnnotationsByType

          public <A extends java.lang.annotation.Annotation> A[] getDeclaredAnnotationsByType(java.lang.Class<A> annotationType)

      Since:
        18.0

    - #### equals

          public boolean equals(@Nullable
                       java.lang.Object obj)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`